/* (c) Copyright 1985 Cary Buchman and Daniel M. Berry */
/* (c) Copyright 1987 Berry Computer Scientists, Ltd. */

/******************************************************* 
******************************************************** 
**                                                    **
** this file includes the main ffortid driver routine **
**                                                    **
******************************************************** 
********************************************************/ 

#include <stdio.h>
#include "TOKEN.h"
#include "TABLE.h"
#include "lex.h"
#include "lexer"
#include "macros.h"

/************************************************************************/
/************************************************************************/

#define  MARK_PREVIOUS_END   in_end->ending = END;
#define  MARK_START_BEGINING in_start->begining = BEGINING; in_start->begining = BEGINING; in_start->prev_space_width=0;

/******************************************************************************/
#define  ADD_CHAR1(TOKTYP,BEGN,CHAR1) prev_token = tokenptr; tokenptr = new_token(TOKTYP,in_size,in_font,in_horizontal,in_vertical,in_lr,BEGN,NOT_END,CHAR1,NULL,NULL,in_font_name,width1(CHAR1,in_size,in_font),FALSE,'\0','\0',0); add_token(tokenptr, &in_start, &in_end )

/******************************************************************************/
#define  ADD_ARABIC_PERSIAN_CHAR1(TOKTYP,BEGN,CHAR1) prev_token = tokenptr; tokenptr = new_token(TOKTYP,in_size,in_font,in_horizontal,in_vertical,in_lr,BEGN,NOT_END,CHAR1,NULL,NULL,in_font_name,width1(CHAR1,in_size,in_font),TRUE,internal_stretchability(yytext+1,in_font),connectivity(yytext+1,in_font),0); add_token(tokenptr, &in_start, &in_end )

/******************************************************************************/
#define  ADD_CHAR2(TOKTYP,BEGN,CHAR1,CHAR2) prev_token = tokenptr; tokenptr = new_token(TOKTYP,in_size,in_font,in_horizontal,in_vertical,in_lr,BEGN,NOT_END,CHAR1,CHAR2,NULL,in_font_name,width2(yytext+1,in_size,in_font),FALSE,'\0','\0',0); add_token(tokenptr, &in_start, &in_end )

/******************************************************************************/
#define  ADD_ARABIC_PERSIAN_CHAR2(TOKTYP,BEGN,CHAR1,CHAR2) prev_token = tokenptr; tokenptr = new_token(TOKTYP,in_size,in_font,in_horizontal,in_vertical,in_lr,BEGN,NOT_END,CHAR1,CHAR2,NULL,in_font_name,width2(yytext+1,in_size,in_font),TRUE,internal_stretchability(yytext+1,in_font),connectivity(yytext+1,in_font),0); add_token(tokenptr, &in_start, &in_end )

/******************************************************************************/
#define  ADD_CHARN(TOKTYP,BEGN,CHAR1,CHAR2,CHAR3) prev_token = tokenptr; tokenptr = new_token(TOKTYP,in_size,in_font,in_horizontal,in_vertical,in_lr,BEGN,NOT_END,CHAR1,CHAR2,CHAR3,in_font_name,widthn(yytext+1,in_size,in_font),FALSE,'\0','\0',0); add_token(tokenptr, &in_start, &in_end )

/******************************************************************************/
#define  ADD_ARABIC_PERSIAN_CHARN(TOKTYP,BEGN,CHAR1,CHAR2,CHAR3) prev_token = tokenptr; tokenptr = new_token(TOKTYP,in_size,in_font,in_horizontal,in_vertical,in_lr,BEGN,NOT_END,CHAR1,CHAR2,CHAR3,in_font_name,widthn(yytext+1,in_size,in_font),TRUE,internal_stretchability(yytext+1,in_font),connectivity(yytext+1,in_font),0); add_token(tokenptr, &in_start, &in_end )

/******************************************************************************/
/* I think this is better ... Johny                                           */
#define  USAGE  "Usage: %s [-wpaperwidth] [-rfont_position_list] [-afont_position_list] [-s[nfla]]\n"
/******************************************************************************/

  double paper_inch=8.5;               /* paper width in inches               */
  int    paper_width;                  /* paper width in points               */
  int   in_font=1;                     /* current input font                  */
  int   in_size=10;                    /* current input size                  */
  int   in_horizontal=0;               /* current input horizontal position   */
  int   in_vertical=0;                 /* current input vertical position     */
  char  in_font_name[3];               /* current input font name             */
  bool  in_lr=LEFT_TO_RIGHT;           /* current input font direction        */
  TABLENTRY in_fontable[256];          /* current input font table            */

  int   out_font=1;                    /* current output font                 */
  int   out_size=10;                   /* current output size                 */
  int   out_horizontal=0;              /* current output horizontal position  */
  int   out_vertical=0;                /* current output vertical position    */
  char  out_font_name[3];              /* current output font name            */
  TABLENTRY out_fontable[256];         /* current output font table           */

  bool  direction_table[256];          /* formatting direction of font i      */
  bool	arabic_persian_fonts[256];     /* if font i is arabic/persian         */
  int   no_arabic_persian_fonts = 0;   /* counter                             */
  char  *stretch_args;                 /* pointer into an argv                */
  char  *no_additional_stretch_args;   /* pointer into an argv                */
  char  stretch_mode = NONE;           /* default is no stretching at all     */
  char  stretch_places = NONE;         /* default is no stretching at all     */
  double stretch_limit = 2.0;          /* 2.0 ems is the default              */
  int favor_distribution = 0;          /* what to do if excess is smaller     */
  int favor_stretch = 1;               /* than filler when stretch ALL        */
  bool left_to_right_sweep = FALSE;    /* direction excess is given to gaps   */
  bool no_add_to_manually_stretched_letter = FALSE;
				       /* normally can stretch manually       */
                                       /* stretched letter                    */
  bool no_add_to_manually_stretched_connection = FALSE;
				       /* normally can stretch manually       */
                                       /* stretched connection                */
#define MAXSTRETCHINGPLACES 100
  TOKENPTR stretching_places[MAXSTRETCHINGPLACES]; /* pointers to stretchable */
						   /* tokens                  */
  char stretching_style[MAXSTRETCHINGPLACES]; /* LETTER or CONNECTION         */
  int connection_stretching_place_index[MAXSTRETCHINGPLACES]; /* indices into */
  int letter_stretching_place_index[MAXSTRETCHINGPLACES]; /* stretching_places*/
  int no_stretching_places = 0;
  int no_connection_stretching_places = 0;
  int no_letter_stretching_places = 0;
  int no_of_words = 0;                 /* calculated as stretch places found  */

  char  *device;                       /* output device                       */
  char  c;                             /* for flushing included postscript    */
                                       /* and psfig text    */

#define MAXNOGAPS 100
  GAPTYPE gaptable[MAXNOGAPS];         /* table of interword gaps             */
  int     no_of_gaps=0;                /* number of INTERword gaps found      */
  double  total_known_spreads = 0;     /* total of additional white space     */
                                       /* added to interword gaps             */
  int     average_known_spread = 0;    /* average of additional white space   */
                                       /* added to interword gaps             */
  int     no_known_spreads = 0;        /* number of interword gaps for whom   */
				       /* additional white space is known     */


  static char copyright[]="(c) Copyright 1987 Berry Computer Scientists, Ltd.";

/******************************************************************************/
/******************************************************************************/

main (argc,argv)
  int          argc;
  char         *argv[];

{

  extern char  yytext[];    /* lex token string                               */

                            /* indicates the predominate formatting direction */
  bool         lr_predom = LEFT_TO_RIGHT;
  TOKENPTR     in_start  = NULL;       /* ptr to start of internal input line */
  TOKENPTR     in_end    = NULL;       /* ptr to end of internal input line   */

  int          token_num;              /* current lex token                   */
  bool         new_word=TRUE;          /* indicates word token was encountered*/
  bool         previous_D=FALSE;       /* indicates a D_token was just done   */
  char         small_motion[3];        /* motion from h or hc token           */
  int          char_space_width_and_spread=0;
                                       /* sum of widths of last char of word  */
                                       /* and following space and spread      */
  int          space_width=0;          /* width of following space            */
  int          small_movement;         /* motion from h or hc token as int    */
  int          abs_horizontal;         /* motion from H token as int          */
  char         f_name[3];              /* new font name                       */
  int          f_num;                  /* new font number                     */
  TOKENPTR     tokenptr = NULL;        /* ptr to current internal token       */
  TOKENPTR     prev_token = NULL;      /* ptr to previous internal token      */
  TOKENPTR     new_token();            /* ptr to new internal token           */
  char         *calloc();
  double       atof();
  int	       stretch_amount=0;       /* from hNNN following x X stretch     */
  int          i,j,k;                  /* counter index  */
  char         *tmpyy;                 /* temp ptr for yytext */

/************************************************************************/
/************************************************************************/

  for (i=0;i<=255;i++) {		/* johny */
    SET_DIRECTION(i,LEFT_TO_RIGHT);
	RESET_ARP_FONT(i);
  }

  if (--argc > 0)
  {
    if (argv[1][0] == '-')
    {
      i=1;
      while(i<= argc)
      {
        switch (argv[i][1])

        {
		  /* specify the fonts to be reversed */
          case 'r':
          case 'R':
            {
              if (strlen(argv[i]) > 2)
                SET_DIRECTION(atoi(argv[i++]+2),RIGHT_TO_LEFT);
              else
                i++;
              while( (i<=argc) && (argv[i][0] != '-') )
                SET_DIRECTION(atoi(argv[i++]),RIGHT_TO_LEFT);
              break;
            }
		  /* specify the Arabic/Persian Fonts. Only these fonts
		  are stretched */
          case 'a':
          case 'p':
          case 'A':
          case 'P':
            {
	      no_arabic_persian_fonts++;
              if (strlen(argv[i]) > 2)
                SET_ARP_FONT(atoi(argv[i++]+2));
              else
                i++;
              while( (i<=argc) && (argv[i][0] != '-') )
                SET_ARP_FONT(atoi(argv[i++]));
              break;
            }
		  /* specify paper width */
          case 'w':
          case 'W':
            {
              if (strlen(argv[i]) > 2)
                paper_inch = atof(argv[i++]+2);
              else
              {
	        if (i == argc) {
		   error(FATAL,
		      "ran out of arguments before giving width value for -w argument\n");
                }
                i++;
                paper_inch = atof(argv[i++]);
              }
	      if(paper_inch == 0.0)
		error(FATAL,
		  "width value for -w argument not in right format\n");
              break;
            }
		/* specify stretching style */
          case 's':
          case 'S':
			{
			stretch_args = argv[i++]+2;
			if (stretch_args[0] == '\0'){
				stretch_mode = EITHER;
				stretch_places = ALL;
			} else {
			    switch(stretch_args[0]){
			    case 'n':
			    case 'N':{
				stretch_mode = NONE;
				stretch_places = NONE;
				break;
			    }
			    case 'l':
			    case 'L':{
				stretch_mode = LETTER;
				break;
			    }
			    case 'c':
			    case 'C':{
				stretch_mode = CONNECTION;
				break;
			    }
			    case 'e':
			    case 'E':{
				stretch_mode = EITHER;
				break;
			    }
			    case 'b':
			    case 'B':{
				stretch_mode = BOTH;
				break;
			    }
			    default:{
				error(FATAL,
				    "bad stretch argument: -s%c, must start with n, or mode = l, c, e, or b\n",
				    stretch_args[0]);
			    }
			    }
			    stretch_args++;
			    if (stretch_args[0] == '\0'){
				if (stretch_mode != NONE) stretch_places = ALL;
			    } else {
				switch(stretch_args[0]){
				case 'f':
				case 'F':{
				    stretch_places = FINAL;
				    break;
				}
				case '2':{
				    stretch_places = FINAL2;
				    break;
				}
				case 'm':
				case 'M':{
				    stretch_places = TO_MAX;
				    /* get rest of arg or next arg as limit */
				    if (strlen(stretch_args) > 1){
					stretch_limit = atof(stretch_args+1);
				    } else {
					if (i > argc) {
					    /* use default */
					    stretch_limit = 2.0;
					} else {
					    stretch_limit = atof(argv[i++]);
					}
				    }
				    if (stretch_limit == 0.0)
					error(FATAL,
					    "limit value for -s?m argument not in right format\n");
				    break;
				}
				case 'a':
				case 'A':{
				    stretch_places = ALL;
				    favor_distribution = 0;
				    favor_stretch = 1;
				    /* get rest of arg or next arg as
				    indication of what to do with excess */
				    if (strlen(stretch_args) > 1){
					switch (stretch_args[1]){
					case 'd': {
					    favor_distribution = 1;
					    favor_stretch = 0;
					    break;
					}
					case 'D': {
					    favor_distribution = 1;
					    favor_stretch = 0;
					    break;
					}
					case 'l': {
					    favor_distribution = 0;
					    favor_stretch = 1;
					    break;
					}
					case 'L': {
					    favor_distribution = 0;
					    favor_stretch = 1;
					    break;
					}
					default: {
					    error(FATAL,
						"extension to stretch ALL not L or D\n");
					    break;
					}
					}
				    }
				    break;
				}
				}
			    }
			}
                        break;
			}
          case 'm':
          case 'M':
			{
			no_additional_stretch_args = argv[i++]+2;
			if (no_additional_stretch_args[0] == '\0'){
				error(FATAL,
					"-m argument must have s and either l or c\n");
			} else {
			    switch(no_additional_stretch_args[0]){
			    case 's':
			    case 'S':{
			    	switch(no_additional_stretch_args[1]){
				    case 'l':
				    case 'L':{
					no_add_to_manually_stretched_letter
						= TRUE;
					break;
				    }
				    case 'c':
				    case 'C':{
					no_add_to_manually_stretched_connection
						= TRUE;
					break;
				    }
				    case '\0':{
					error(FATAL,
						"-m argument must have s and either l or c\n");
					break;
				    }
				    default:{
					error(FATAL,
						"-m argument must have s and either l or c\n");
				    }
				}
				break;
			    }
			    default:{
				error(FATAL,
					"-m argument must have s and either l or c\n");
				}
			    }
			}
			break;
                        }
          default:
            {
              fprintf(stderr,"FFORTID: illegal argument: %s\n",argv[i]);
              exit(1);
              break;
            }
        }
      }
    }
    else
    {
      printf(USAGE,argv[0]);
      exit(1);
    }
  }

/************************************************************************/
/************************************************************************/

  while ( (token_num=yylex()) ) /* get each token until the end-of-file */
  {


    switch (token_num)                 /* process based on token type */
    {

      case s_token:
           {
             in_size = atoi(yytext+1);
             break;
           }

      case f_token:
           {
             in_font = atoi(yytext+1);
             in_lr   = in_fontable[in_font].direction;
             strcpy(in_font_name,in_fontable[in_font].name);
             break;
           }
      case c_token:
           {
             if (in_end != NULL) {
                 if (in_end->horizontal_pos == in_horizontal) {
        	     in_end->width = 0;
                 }
             }
             if (new_word)
             {
               if (arabic_persian_fonts[in_font] == ARABIC_PERSIAN){
                  ADD_ARABIC_PERSIAN_CHAR1(c_token,BEGINING,*(yytext+1));
                  if (prev_token != NULL){
                     gaptable[no_of_gaps].before_token = prev_token;
                     gaptable[no_of_gaps].after_token = tokenptr;
                     gaptable[no_of_gaps].actual_movement =
                         char_space_width_and_spread;
                     no_of_gaps++;
                  }
                  new_word =FALSE;
                  if (stretch_amount != 0){
                        tokenptr->already_stretched_amount = stretch_amount;
                        tokenptr->width += stretch_amount;
                        in_horizontal += stretch_amount;
                        stretch_amount = 0;
                  }
               } else {
                  ADD_CHAR1(c_token,BEGINING,*(yytext+1));
                  if (prev_token != NULL){
                     gaptable[no_of_gaps].before_token = prev_token;
                     gaptable[no_of_gaps].after_token = tokenptr;
                     gaptable[no_of_gaps].actual_movement =
                         char_space_width_and_spread;
                     no_of_gaps++;
                  }
                  new_word =FALSE;
               }
             }
             else
             {
               if (arabic_persian_fonts[in_font] == ARABIC_PERSIAN){
                  ADD_ARABIC_PERSIAN_CHAR1(c_token,NOT_BEGIN,*(yytext+1));
                  if (stretch_amount != 0){
                        tokenptr->already_stretched_amount = stretch_amount;
                        tokenptr->width += stretch_amount;
                        in_horizontal += stretch_amount;
                        stretch_amount = 0;
                  }
               } else {
                  ADD_CHAR1(c_token,NOT_BEGIN,*(yytext+1));
               }
             }
             break;
           }
      case C_token:
           {
             if (in_end != NULL) {
                 if (in_end->horizontal_pos == in_horizontal) {
                     in_end->width = 0;
                 }
             }
             if (new_word)
             {
               if (arabic_persian_fonts[in_font] == ARABIC_PERSIAN){
                  ADD_ARABIC_PERSIAN_CHAR2(
                        C_token,BEGINING,*(yytext+1),*(yytext+2));
                  if (prev_token != NULL){
                     gaptable[no_of_gaps].before_token = prev_token;
                     gaptable[no_of_gaps].after_token = tokenptr;
                     gaptable[no_of_gaps].actual_movement =
                         char_space_width_and_spread;
                     no_of_gaps++;
                  }
                  new_word = FALSE;
                  if (stretch_amount != 0){
                        tokenptr->already_stretched_amount = stretch_amount;
                        tokenptr->width += stretch_amount;
                        in_horizontal += stretch_amount;
                        stretch_amount = 0;
                  }
               } else {
                  ADD_CHAR2(C_token,BEGINING,*(yytext+1),*(yytext+2));
                  if (prev_token != NULL){
                     gaptable[no_of_gaps].before_token = prev_token;
                     gaptable[no_of_gaps].after_token = tokenptr;
                     gaptable[no_of_gaps].actual_movement =
                         char_space_width_and_spread;
                     no_of_gaps++;
                  }
                  new_word = FALSE;
               }
             }
             else
             {
               if (arabic_persian_fonts[in_font] == ARABIC_PERSIAN){
                  ADD_ARABIC_PERSIAN_CHAR2(
                        C_token,NOT_BEGIN,*(yytext+1),*(yytext+2));
                  if (stretch_amount != 0){
                        tokenptr->already_stretched_amount = stretch_amount;
                        tokenptr->width += stretch_amount;
                        in_horizontal += stretch_amount;
                        stretch_amount = 0;
                  }
               } else {
                  ADD_CHAR2(C_token,NOT_BEGIN,*(yytext+1),*(yytext+2));
               }
             }
             break;
           }
      case N_token:
           {
             if (in_end != NULL) {
                 if (in_end->horizontal_pos == in_horizontal) {
                     in_end->width = 0;
                 }
             }
             if (new_word)
             {
	       if (arabic_persian_fonts[in_font] == ARABIC_PERSIAN){
                  ADD_ARABIC_PERSIAN_CHARN(
			N_token,BEGINING,*(yytext+1),*(yytext+2),*(yytext+3));
                  if (prev_token != NULL){
                     gaptable[no_of_gaps].before_token = prev_token;
                     gaptable[no_of_gaps].after_token = tokenptr;
                     gaptable[no_of_gaps].actual_movement =
                         char_space_width_and_spread;
                     no_of_gaps++;
                  }
                  new_word = FALSE;
		  if (stretch_amount != 0){
			tokenptr->already_stretched_amount = stretch_amount;
			tokenptr->width += stretch_amount;
             		in_horizontal += stretch_amount;
			stretch_amount = 0;
		  }
	       } else {
                  ADD_CHARN(
			N_token,BEGINING,*(yytext+1),*(yytext+2),*(yytext+3));
                  if (prev_token != NULL){
                     gaptable[no_of_gaps].before_token = prev_token;
                     gaptable[no_of_gaps].after_token = tokenptr;
                     gaptable[no_of_gaps].actual_movement =
                         char_space_width_and_spread;
                     no_of_gaps++;
                  }
                  new_word = FALSE;
	       }
             }
             else
             {
	       if (arabic_persian_fonts[in_font] == ARABIC_PERSIAN){
                  ADD_ARABIC_PERSIAN_CHARN(
			N_token,NOT_BEGIN,*(yytext+1),*(yytext+2),*(yytext+3));
		  if (stretch_amount != 0){
			tokenptr->already_stretched_amount = stretch_amount;
			tokenptr->width += stretch_amount;
             		in_horizontal += stretch_amount;
			stretch_amount = 0;
		  }
	       } else {
                  ADD_CHARN(
			N_token,NOT_BEGIN,*(yytext+1),*(yytext+2),*(yytext+3));
	       }
             }
             break;
           }
      case H_token:
           {
             abs_horizontal = atoi(yytext+1);
             small_movement = abs_horizontal - in_horizontal;
             in_horizontal = abs_horizontal;
             if (new_word) {

/*              printf("\n##!case of absolute movement (H) after word end!"); */

                if (in_end == NULL) {
                    char_space_width_and_spread = small_movement;
                } else {
                    char_space_width_and_spread = small_movement +
                        in_end->already_stretched_amount;
                }
             } else {
                if (in_end != NULL) {

/*                 if (in_end->width !=
                       small_movement + in_end->already_stretched_amount) {
                      printf("\n##! movement is %d and calculated width is %d",
                          small_movement + in_end->already_stretched_amount,
                          in_end->width);
                   } */

                  in_end->width=small_movement+in_end->already_stretched_amount;
                }
             }
             break;
           }
      case V_token:
           {
             in_vertical = atoi(yytext+1);
             break;
           }
      case h_token:
           {
             small_movement = atoi(yytext+1);
             in_horizontal = in_horizontal + small_movement;
             if (new_word) {
                if (in_end == NULL) {
                    char_space_width_and_spread = small_movement;
                } else {
                    char_space_width_and_spread = small_movement +
                        in_end->already_stretched_amount;
                }
             } else {
                if (in_end != NULL) {

/*                 if (in_end->width !=
                       small_movement + in_end->already_stretched_amount) {
                           printf("\n#!movement is %d & calculated width is %d",
                                small_movement +
                                in_end->already_stretched_amount,
                                in_end->width);
                    } */

                  in_end->width=small_movement+in_end->already_stretched_amount;
                }
             }
             break;
           }
      case v_token:
           {
             in_vertical = in_vertical + atoi(yytext+1);
             break;
           }
      case hc_token:
           {
             small_motion[0] = *(yytext);
             small_motion[1] = *(yytext+1);
             small_motion[2] = '\0';
             small_movement = atoi(small_motion);
             in_horizontal = in_horizontal + small_movement;

             if (new_word) {
                if (in_end == NULL) {
                    char_space_width_and_spread = small_movement;
                } else {
                    char_space_width_and_spread = small_movement +
                        in_end->already_stretched_amount;
                }
             } else {

/*              if (in_end->width !=
                    small_movement + in_end->already_stretched_amount) {
                       printf("\n##! movement is %d and calculated width is %d",
                           small_movement + in_end->already_stretched_amount,
                           in_end->width);
                } */

                in_end->width=small_movement+in_end->already_stretched_amount;
             }
             if (new_word)
             {
               if (arabic_persian_fonts[in_font] == ARABIC_PERSIAN){
                  ADD_ARABIC_PERSIAN_CHAR1(c_token,BEGINING,*(yytext+2));
                  if (prev_token != NULL){
                     gaptable[no_of_gaps].before_token = prev_token;
                     gaptable[no_of_gaps].after_token = tokenptr;
                     gaptable[no_of_gaps].actual_movement =
                         char_space_width_and_spread;
                     no_of_gaps++;
                  }
                  new_word = FALSE;
                  if (stretch_amount != 0){
                        tokenptr->already_stretched_amount = stretch_amount;
                        tokenptr->width += stretch_amount;
                        in_horizontal += stretch_amount;
                        stretch_amount = 0;
                  }
               } else {
                  ADD_CHAR1(c_token,BEGINING,*(yytext+2));
                  if (prev_token != NULL){
                     gaptable[no_of_gaps].before_token = prev_token;
                     gaptable[no_of_gaps].after_token = tokenptr;
                     gaptable[no_of_gaps].actual_movement =
                         char_space_width_and_spread;
                     no_of_gaps++;
                  }
                  new_word = FALSE;
               }
             }
             else
             {
               if (arabic_persian_fonts[in_font] == ARABIC_PERSIAN){
                  ADD_ARABIC_PERSIAN_CHAR1(c_token,NOT_BEGIN,*(yytext+2));
                  if (stretch_amount != 0){
                        tokenptr->already_stretched_amount = stretch_amount;
                        tokenptr->width += stretch_amount;
                        in_horizontal += stretch_amount;
                        stretch_amount = 0;
                  }
               } else {
                  ADD_CHAR1(c_token,NOT_BEGIN,*(yytext+2));
               }
             }
             break;
           }
      case n_token:
           {
             if (!previous_D)
             {
               if(in_end != NULL)
               {
		 MARK_START_BEGINING;
                 MARK_PREVIOUS_END;
                 adjust_gaps();
                 if (lr_predom)
                   dump_line(&in_start,&in_end,RIGHT_TO_LEFT);
                 else
                 {
                   reverse_line(&in_start,&in_end,paper_width);
                   dump_line(&in_start,&in_end,LEFT_TO_RIGHT);
                 }
               }
             } else {
                 previous_D = FALSE;
             }
             DUMP_LEX(yytext);
             break;
           }
      case w_token:
           {
             if(in_end != NULL)
               MARK_PREVIOUS_END;
             new_word = TRUE;
             break;
           }
      case p_token:
           {
             put_page_token(yytext);
             break;
           }
      case trail_token:
      case pause_token:
      case height_token:
      case slant_token:
      case include_token:
      case control_token:
           {
             DUMP_LEX(yytext);
             break;
           }
      case res_token:
           {
             DUMP_LEX(yytext);
             for(tmpyy=yytext;(*tmpyy<'0')||(*tmpyy>'9');tmpyy++);
             paper_width = paper_inch * atoi(tmpyy);
             break;
           }
      case init_token:
           {
             DUMP_LEX(yytext);
             width_init();
             break;
           }
      case stop_token:
           {
             printf("V%d\n",in_vertical);
             DUMP_LEX(yytext);
             break;
           }
      case newline_token:
           {
             break;
           }
      case dev_token:
           {
             device = calloc(1,strlen(yytext)-3);
             strcpy(device,yytext+4);
             DUMP_LEX(yytext);
             break;
           }
      case font_token:
           {
             font_info(yytext,&f_num,f_name);
             new_font(f_num,f_name,FONT_DIRECTION(f_num),in_fontable);
             loadfont(f_num,f_name);

/*           if (f_num==42) {
	        printf("\nfont tables for %s in pos %d\n\n", f_name, f_num);
	        fontprint(42);
             } */

             strcpy (out_fontable[f_num].name,in_fontable[f_num].name);
             out_fontable[f_num].direction = in_fontable[f_num].direction;
             DUMP_LEX(yytext);
             break;
           }
      case PR_token:
           {
             lr_predom = RIGHT_TO_LEFT;
             break;
           }
      case PL_token:
           {
             lr_predom = LEFT_TO_RIGHT;
             break;
           }
      case stretch_token_h:
           {
             stretch_amount = atoi(yytext+13);

/*           printf("stretch_amount=%s\n",yytext+13);
             printf("stretch_amount=%d\n",stretch_amount); */

             break;
           }
      case stretch_token_no_h:
           {
             small_motion[0] = *(yytext+12);
             small_motion[1] = *(yytext+13);
             small_motion[2] = '\0';
             stretch_amount = atoi(small_motion);

/*           printf("stretch_token=%s\n",yytext+12);
             printf("small_motion=%s\n",small_motion);
             printf("stretch_amount=%d\n",stretch_amount);
             printf("char=%c\n",*(yytext+14)); */

             if (new_word)
             {
               if (arabic_persian_fonts[in_font] == ARABIC_PERSIAN){
                  ADD_ARABIC_PERSIAN_CHAR1(c_token,BEGINING,*(yytext+14));
                  if (prev_token != NULL){
                     gaptable[no_of_gaps].before_token = prev_token;
                     gaptable[no_of_gaps].after_token = tokenptr;
                     gaptable[no_of_gaps].actual_movement =
                         char_space_width_and_spread;
                     no_of_gaps++;
                  }
                  new_word = FALSE;
                  if (stretch_amount != 0){
                        tokenptr->already_stretched_amount = stretch_amount;
                        tokenptr->width += stretch_amount;
                        in_horizontal += stretch_amount;
                        stretch_amount = 0;
                  }
               } else {
                  ADD_CHAR1(c_token,BEGINING,*(yytext+14));
                  if (prev_token != NULL){
                     gaptable[no_of_gaps].before_token = prev_token;
                     gaptable[no_of_gaps].after_token = tokenptr;
                     gaptable[no_of_gaps].actual_movement =
                         char_space_width_and_spread;
                     no_of_gaps++;
                  }
                  new_word = FALSE;
               }
             }
             else
             {
               if (arabic_persian_fonts[in_font] == ARABIC_PERSIAN){
                  ADD_ARABIC_PERSIAN_CHAR1(c_token,NOT_BEGIN,*(yytext+14));
                  if (stretch_amount != 0){
                        tokenptr->already_stretched_amount = stretch_amount;
                        tokenptr->width += stretch_amount;
                        in_horizontal += stretch_amount;
                        stretch_amount = 0;
                  }
               } else {
                  ADD_CHAR1(c_token,NOT_BEGIN,*(yytext+14));
               }
             }
             break;
           }
      case postscript_begin_token:
           {
             DUMP_LEX(yytext);
                /* copy everything up to and including 2 lines */
                /* containing PE\ and .\ */
                while ( ( c = getchar() ) != EOF ) {
			putchar(c);
			if ( c == 'P' ) {
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'E') goto not_end_PS_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != '\\') goto not_end_PS_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != '\n') goto not_end_PS_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != '.') goto not_end_PS_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != '\\') goto not_end_PS_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != '\n') goto not_end_PS_yet;
				}
				goto done_flushing_PS;
			}
		not_end_PS_yet:;
                }
             goto done;
	     done_flushing_PS:
             break;
           }
      case psfig_begin_token:
           {
             printf("H%d\n",in_horizontal);
             printf("V%d\n",in_vertical);
             DUMP_LEX(yytext);
                /* copy everything up to and including line */
                /* containing "x X pendFig"*/
                while ( ( c = getchar() ) != EOF ) {
			putchar(c);
			if ( c == 'x' ) {
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != ' ') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'X') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != ' ') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'p') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'e') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'n') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'd') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'F') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'i') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'g') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != '\n') goto not_end_psfig_yet;
				}
				goto done_flushing_psfig;
			}
		not_end_psfig_yet:;
                }
             goto done;
	     done_flushing_psfig:
             break;
           }
      case D_token:
           {
             printf("H%d\n",in_horizontal);
             printf("V%d\n",in_vertical);
             printf("%s\n",yytext);
             tmpyy = yytext+1;
             if (*tmpyy == 'l' || *tmpyy == '-')
             {
               k = 0;
               while( ((*tmpyy < '0') || (*tmpyy > '9')) && (*tmpyy != '-') )
                 tmpyy++;
               while (*tmpyy != '\0')
               {
                 if(k=1-k)
                   in_horizontal += atoi(tmpyy);
                 else
                   in_vertical   += atoi(tmpyy);
                 while(((*tmpyy >= '0') && (*tmpyy <= '9')) || (*tmpyy == '-') )
                   tmpyy++; 
                 while( ((*tmpyy < '0') || (*tmpyy > '9')) && (*tmpyy != '-')
                        && (*tmpyy != '\0') )
                   tmpyy++;
               }
             }
             out_horizontal = in_horizontal;
             out_vertical = in_vertical;
             previous_D = TRUE;
           }
    } /* end switch */
  }  /* end while */
  done:;
} /* end main() */

adjust_gaps()
{

  int i;
  char char_name[4];

/* initializing gaptable info from the pointers to the before and after
tokens */

/* printf("\nbefore first pass\n"); */

 for (i= 0; i <= no_of_gaps-1; i++) {
    TOKENPTR prev_token = gaptable[i].before_token;
    TOKENPTR tokenptr = gaptable[i].after_token;
    gaptable[i].before_font = prev_token->font;
    gaptable[i].after_font = tokenptr->font;
    gaptable[i].before_point_size = prev_token->point_size;
    gaptable[i].after_point_size = tokenptr->point_size;

/*  if (gaptable[i].actual_movement !=
        tokenptr->horizontal_pos - prev_token->horizontal_pos)
           printf(
          "\nactual_movement not diff of horizontal pos's in gaptable[%d]\n",
           i); */

    gaptable[i].before_trial_space_width = width1(' ',
        gaptable[i].before_point_size,gaptable[i].before_font);
    gaptable[i].after_trial_space_width = width1(' ',
        gaptable[i].after_point_size,gaptable[i].after_font);

    gaptable[i].both_trial_space_widths_the_same =
        (gaptable[i].before_trial_space_width ==
         gaptable[i].after_trial_space_width);

    gaptable[i].before_char_width = prev_token->width;

    if (gaptable[i].both_trial_space_widths_the_same) {
	gaptable[i].final_space_width = gaptable[i].before_trial_space_width;
        gaptable[i].final_space_spread = gaptable[i].actual_movement -
             gaptable[i].before_char_width - gaptable[i].final_space_width;
	total_known_spreads += (double) gaptable[i].final_space_spread;
	no_known_spreads++;
	gaptable[i].definite = TRUE;
    } else {
	gaptable[i].definite = FALSE;
    }
 }

/* printf("\nafter first pass, no of gaps: %d no known spreads:%d\n",
       no_of_gaps,no_known_spreads);
   print_gaptable(no_of_gaps); */

 if (no_known_spreads > 0) {
     average_known_spread =
	 (int) ((total_known_spreads / (double) no_known_spreads) +.5);

/*   printf("\nno known spreads:%d, total known spreads:%f average: %d\n",
           no_known_spreads, total_known_spreads, average_known_spread); */

     /* second pass to jiggle the non-definites into something definite */
    
     for (i= 0; i <= no_of_gaps-1; i++) {
    
        if ( !gaptable[i].definite) {
            int before_trial_stretch = gaptable[i].actual_movement -
                 gaptable[i].before_char_width -
                 gaptable[i].before_trial_space_width;
            int after_trial_stretch = gaptable[i].actual_movement -
                 gaptable[i].before_char_width -
                 gaptable[i].after_trial_space_width;
    	
            if ((before_trial_stretch > average_known_spread+1) ||
                (before_trial_stretch < average_known_spread-1)) {
    
    
                gaptable[i].final_space_width =
                    gaptable[i].after_trial_space_width;
                gaptable[i].final_space_spread = gaptable[i].actual_movement -
                    gaptable[i].before_char_width -
                        gaptable[i].final_space_width;
                total_known_spreads += (double)gaptable[i].final_space_spread;
                no_known_spreads++;
    
    
    
    
                gaptable[i].definite = TRUE;
            } else if ((after_trial_stretch > average_known_spread+1) ||
                       (after_trial_stretch < average_known_spread-1)) {
    
    
                gaptable[i].final_space_width =
                    gaptable[i].before_trial_space_width;
                gaptable[i].final_space_spread = gaptable[i].actual_movement -
                    gaptable[i].before_char_width -
                    gaptable[i].final_space_width;
                total_known_spreads += (double)gaptable[i].final_space_spread;
                no_known_spreads++;
    
    
    
    
                gaptable[i].definite = TRUE;
            } else {
    
                int smaller = gaptable[i].before_trial_space_width;
                if (gaptable[i].after_trial_space_width < smaller) {
                    smaller = gaptable[i].after_trial_space_width;
                }
    
                gaptable[i].final_space_width = smaller;
                gaptable[i].final_space_spread = gaptable[i].actual_movement -
                    gaptable[i].before_char_width -
                    gaptable[i].final_space_width;
                total_known_spreads += (double)gaptable[i].final_space_spread;
                no_known_spreads++;
    
    
    
                gaptable[i].definite = TRUE;
            }
    
        }
     }

 } else {

     /* second pass to assign minimum of the choices if nothing was definite */

/*   printf("\nminimizing second pass\n"); */
    
     for (i= 0; i <= no_of_gaps-1; i++) {
        int smaller = gaptable[i].before_trial_space_width;
        if (gaptable[i].after_trial_space_width < smaller) {
            smaller = gaptable[i].after_trial_space_width;
        }
   
        gaptable[i].final_space_width = smaller;
        gaptable[i].final_space_spread = gaptable[i].actual_movement -
            gaptable[i].before_char_width -
            gaptable[i].final_space_width;
        total_known_spreads += (double) gaptable[i].final_space_spread;
        no_known_spreads++;
  
 

        gaptable[i].definite = TRUE;
     }
 }

/* printf("\nafter second pass, no of gaps: %d\n",no_of_gaps);
   print_gaptable(no_of_gaps); */

 for (i= 0; i <= no_of_gaps-1; i++) {
     if (! gaptable[i].definite) {
	 fprintf(stderr, "somehow after all gaps were made definite, at least one is not!\n");
     } else {
	 TOKENPTR b = gaptable[i].before_token;
	 TOKENPTR a = gaptable[i].after_token;
	 b->next_space_width = gaptable[i].final_space_width;
	 b->next_space_spread = gaptable[i].final_space_spread;
	 a->prev_space_width = gaptable[i].final_space_width;
	 a->prev_space_spread = gaptable[i].final_space_spread;
     }
 }

 for (i= 0; i <= no_of_gaps-1; i++) {
    gaptable[i].before_token = NULL;
    gaptable[i].after_token = NULL;
    gaptable[i].before_font = 0;
    gaptable[i].after_font = 0;
    gaptable[i].before_point_size = 0;
    gaptable[i].after_point_size = 0;
    gaptable[i].before_trial_space_width = 0;
    gaptable[i].after_trial_space_width = 0;
    gaptable[i].before_char_width = 0;
    gaptable[i].actual_movement = 0;
    gaptable[i].both_trial_space_widths_the_same = 0;
    gaptable[i].definite = 0;
    gaptable[i].final_space_width = 0;
    gaptable[i].final_space_spread = 0;
 }
 total_known_spreads = 0;
 average_known_spread = 0;
 no_known_spreads = 0;
 no_of_gaps = 0;

/* printf("\njust before return, no of gaps: %d\n",no_of_gaps); */

}

print_gaptable(no_of_gaps)
   int no_of_gaps;

{
   int i;

   for (i= 0; i <= no_of_gaps-1; i++) {
       printf("\ngaptable[%d]:\nbefore token:%d after token:%d before font:%d after font:%d before point size:%d\nafter point size:%d before trial space width:%d after trial space width:%d\nbefore char width:%d actual movement:%d both trial space widths the same:%d\ndefinite:%d final space width:%d final spread:%d\n",
           i,
           gaptable[i].before_token,
           gaptable[i].after_token,
           gaptable[i].before_font,
           gaptable[i].after_font,
           gaptable[i].before_point_size,
           gaptable[i].after_point_size,
           gaptable[i].before_trial_space_width,
           gaptable[i].after_trial_space_width,
           gaptable[i].before_char_width,
           gaptable[i].actual_movement,
           gaptable[i].both_trial_space_widths_the_same,
           gaptable[i].definite,
           gaptable[i].final_space_width,
           gaptable[i].final_space_spread);
   }
}
